/*!
  @file rx_trackball.h
	
  @brief ȈՃgbN{[
 
  @author Makoto Fujisawa
  @date 2008
*/
// FILE --rx_trackball.h--

#ifndef _RX_TRACKBALL_H_
#define _RX_TRACKBALL_H_


//-----------------------------------------------------------------------------
// l֐
//-----------------------------------------------------------------------------
void QuatLerp(double p[], const double q0[], const double q1[], const double t);
void QuatMultiLerp(double p[], const double t[], const double q[][4], const int n, const double u);
void SetQuat(double q[], const double ang, const double ax, const double ay, const double az);


//-----------------------------------------------------------------------------
// gbN{[֐
//-----------------------------------------------------------------------------
class rxTrackball
{
public:
	rxTrackball();
	~rxTrackball();

	// Ɛݒ
	void Init(void);			//!< gbN{[̏
	void SetRegion(int w, int h);	//!< ʗ̈w
	void SetSpace(double l);		//!< 3DԂ̑傫w

	// }EXhbO
	void Start(int x, int y, int button);	//!< hbOJn
	void Motion(int x, int y, bool last = false);				//!< hbO
	void Stop(int x, int y);				//!< hbO~

	void TrackballLastRot(void);
	void TrackballRot(double vx, double vy);

	// ANZX\bh
	void GetQuaternion(double q[4]) const;
	double GetScaling(void) const;		//!< XP[OʂԂ
	void GetScaling(double &s) const;
	double GetTranslation(int i) const;
	void GetTranslation(double t[2]) const;

	double *GetRotation(void);		//!< ]̕ϊsԂ
	double *GetQuaternionR(void);	//!< lԂ(q[4])
	double *GetTranslationR(void);	//!< sړʂԂ(t[2])
	double *GetScalingR(void);		//!< XP[OʂԂ(s)

	void GetTransform(double m[16]);

	void GetLastVeloc(int &vx, int &vy);

	void CalGlobalPos(double dst[4], const double src[4]);
	void CalLocalPos(double dst[4], const double src[4]);

	void CalGlobalRot(double dst[4], const double src[4]);
	void CalLocalRot(double dst[4], const double src[4]);

	void GetViewPosition(double pos[3]);
	void GetViewDirection(double dir[3]);

	// `ݒ
	void ApplyRotation(void);		//!< ]OpenGLɐݒ
	void ApplyScaling(void);		//!< XP[OOpenGLɐݒ
	void ApplyTranslation(void);	//!< sړʂOpenGLɐݒ

	void Apply(void);

	void ApplyQuaternion(const double q[4]);		//!< ]OpenGLɐݒ


	void SetScaling(double z);					
	void SetTranslation(double x, double y);
	void SetQuaternion(double q[4]);
	void SetRotation(double ang, double x, double y, double z);
	void SetRotation(double rot[16]);

	void AddRotation(double ang, double x, double y, double z);
	void GetLastRotation(double &ang, double &x, double &y, double &z);

	void GetRayTo(int x, int y, double fov, double ray_to[3]);

private:
	double m_fTransScale;		//!< }EX̑ΈʒuXP[OCsړʂ̊ZW

	int m_iSx, m_iSy;	//!< hbOJnʒu
	int m_iPx, m_iPy;	//!< hbOJnʒu
	double m_fW, m_fH;	//!< }EX̐ΈʒuEBhEł̑ΈʒůZW

	int m_iVeloc[2];

	double m_fQuatRot[4];		//!< ](NH[^jI)
	double m_fQuatIncRot[4];	//!< hbỎ](NH[^jI)
	double m_fMatRot[16];		//!< ]̕ϊs
	
	double m_fTransDist[2];		//!< Jp
	double m_fScaleDist;		//!< XP[O
	int m_iDrag;				//!< hbOۂ(1:hbO, 2:EhbO, 3:~hhbO)

	double m_fLastRot[4];		//!< Ō̉]

};


#endif // #ifndef _RX_TRACKBALL_H_